#include <iostream>
#include "myMain.h"
#include "pugixml.hpp"
#include "Circle.h"
#include "Group.h"

using namespace std;
int myMain()
{
    std::string sc = R"(<?xml version = "1.0"?>
                        <Circle label="testCircle" x="0" y="1" r="2" color="Black" />)";
    pugi::xml_document doc;
    pugi::xml_parse_result result = doc.load_string(sc.c_str());
    if (!result) {
        cerr << result.description();
        exit(1);
    } 
    pugi::xml_node node = doc.child("Circle");
    Circle c{ node.attribute("label").as_string(),
              node.attribute("x").as_double(),
              node.attribute("y").as_double(),
              node.attribute("r").as_double(),
              node.attribute("color").as_string() };
    cout << c.dump();

    std::string sg = R"(<?xml version = "1.0"?>
                       <Group label="testGroup" x="0" y="1">
                           <Circle label="testCircle1" x="2" y="3" r="4" color="Black"/>
                           <Circle label="testCircle2" x="5" y="6" r="7" color="Black"/>
                       </Group>)";
    result = doc.load_string(sg.c_str());
    if (!result) {
        cerr << result.description();
        exit(1);
    }
    pugi::xml_node nodeGroup = doc.child("Group");
    Group g{ nodeGroup.attribute("label").as_string(),
             nodeGroup.attribute("x").as_double(),
             nodeGroup.attribute("y").as_double() };
    for (pugi::xml_node nodeCircle : nodeGroup.children("Circle"))
    {
        Circle cg{ nodeCircle.attribute("label").as_string(),
                   nodeCircle.attribute("x").as_double(),
                   nodeCircle.attribute("y").as_double(),
                   nodeCircle.attribute("r").as_double(),
                   nodeCircle.attribute("color").as_string() };
        g.children.push_back(cg);
    }
    cout << g.dump();

    return 0;
}